include zlib.e
include whole.e
include CRC.e
include misc.e

constant to_print=0
function abs( object a )
    if atom(a) then
        if a < 0 then
            return -a
        else
            return a
        end if
    else
        for i = 1 to length(a) do
            a[i] = abs(a[i])
        end for

        return a
    end if
    
end function

constant
        passes={
{{{1,1}}},
{{{5,1}}},
{{{1,5},{5,5}}},
{{{3,1},{7,1}},{{3,5},{7,5}}},
{{{1,3},{3,3},{5,3},{7,3}},{{1,7},{3,7},{5,7},{7,7}}},
{{{2,1},{4,1},{6,1},{8,1}},{{2,3},{4,3},{6,3},{8,3}},{{2,5},{4,5},{6,5},{8,5}},{{2,7},{4,7},{6,7},{8,7}}},
{
        {{1,2},{2,2},{3,2},{4,2},{5,2},{6,2},{7,2},{8,2}},
        {{1,4},{2,4},{3,4},{4,4},{5,4},{6,4},{7,4},{8,4}},
        {{1,6},{2,6},{3,6},{4,6},{5,6},{6,6},{7,6},{8,6}},
        {{1,8},{2,8},{3,8},{4,8},{5,8},{6,8},{7,8},{8,8}}}
        }
--1
--
--
--
--
--
--
--

--1       2
--
--
--
--
--
--
--

--1       2
--
--
--
--3       3
--
--
--

--1   4   2   4
--
--
--
--3   4   3   4
--
--
--

--1   4   2   4
--
--5   5   5   5
--
--3   4   3   4
--
--5   5   5   5
--

--1 6 4 6 2 6 4 6
--
--5 6 5 6 5 6 5 6
--
--3 6 4 6 3 6 4 6
--
--5 6 5 6 5 6 5 6
--

--1 6 4 6 2 6 4 6
--7 7 7 7 7 7 7 7
--5 6 5 6 5 6 5 6
--7 7 7 7 7 7 7 7
--3 6 4 6 3 6 4 6
--7 7 7 7 7 7 7 7
--5 6 5 6 5 6 5 6
--7 7 7 7 7 7 7 7

function get_pass_width(atom w, atom p)
        atom rem,ret
        ret=floor(w/8)*length(passes[p][1])
        rem=remainder(w,8)
        for i = 1 to length(passes[p][1]) do
                if passes[p][1][i][1]<=rem then ret+=1 end if
        end for
        return ret
end function

function get_pass_height(atom h, atom p)
        atom rem,ret
        ret=floor(h/8)*length(passes[p])
        rem=remainder(h,8)
        for i = 1 to length(passes[p]) do
                if passes[p][i][1][2]<=rem then ret+=1 end if
        end for
        return ret
end function

function Paeth(integer a, integer b, integer c)
integer p,pa,pb,pc
    p = a + b - c
    pa = abs(p - a)
    pb = abs(p - b)
    pc = abs(p - c)
    if pa <= pb and pa <= pc then return a
    elsif pb <= pc then return b
    else return c
    end if
end function

procedure putw(atom fn, object num)
        if atom(num) then
                puts(fn,and_bits(num,#FF))
                puts(fn,floor(num/256))
        else
                for i = 1 to length(num) do
                        putw(fn,num[i])
                end for
        end if
end procedure

global procedure Out_TGA(object fn, atom image, atom width, atom height, atom num)
        fn=open(fn,"wb")
        if fn=-1 then return end if
--    /*
--     *  Write file header.
--     */
        puts(fn,0)--Header length
        puts(fn,0)--Color Map Type. There's no color map here (0).
        puts(fn,2)--And then the Image Type. Uncompressed True Color (2) is the only one supported by TGASAVE.
        puts(fn,{0,0,0,0,0})--The 5 Color Map Specification bytes should be 0, since we don'e use no color table.
        putw(fn,{0,0})
--    /*
--     *  Now we should output the image specification. The last byte
--     *  written (32) indicates that the first pixel is upper left on
--     *  the screen. TGASAVE supports 24-bit pixels only.
--     */
        putw(fn,{width,height})
        puts(fn,{num*8,32})
--    /*
--     *  Now we write the Image ID string.
--     */
--      puts(fn,repeat(0,256))
--    /*
--     *  Write the image data.
--     */

--        puts(fn,peek({image,num*width*height}))
        for y = 0 to height-1 do
        for x= 0 to width-1 do
        puts(fn,peek(image+(x+y*width)*num+2))
        puts(fn,peek(image+(x+y*width)*num+1))
        puts(fn,peek(image+(x+y*width)*num+0))
        puts(fn,peek(image+(x+y*width)*num+3))
        end for
        end for

--    /*
--     *  Write footer, and close the file.
--     */

--    /*
--     *  Now we get to the actual footer. Write offset of Extension
--     *  Area and Developer Area, followed by the signature.
--     */
        putw(fn,{0,0})
        puts(fn,"TRUEVISION-XFILE."&0)
        close(fn)
end procedure

function Get_Bits(sequence a, atom loc, atom bits)
        atom ret
        if bits=1 then
                ret=a[loc]
                loc=7-floor((loc-floor(loc))*8)
                ret=and_bits(floor(ret/power(2,loc)),1)
        elsif bits=2 then
                ret=a[loc]
                loc=7-floor((loc-floor(loc))*8)-1
                ret=and_bits(floor(ret/power(2,loc)),3)
        elsif bits=4 then
                ret=a[loc]
                loc=7-floor((loc-floor(loc))*8)-3
                ret=and_bits(floor(ret/power(2,loc)),15)
        elsif bits=8 then
                return a[loc]
        elsif bits=16 then
                return (a[loc]*256+a[loc+1])
        end if
        return ret
end function

function Get_sBits(sequence a, atom loc, atom bits)
        atom ret
        if bits=1 then
                ret=a[loc]
                loc=7-floor((loc-floor(loc))*8)
                ret=and_bits(floor(ret/power(2,loc)),1)/#1
        elsif bits=2 then
                ret=a[loc]
                loc=7-floor((loc-floor(loc))*8)-1
                ret=and_bits(floor(ret/power(2,loc)),3)/#3
        elsif bits=4 then
                ret=a[loc]
                loc=7-floor((loc-floor(loc))*8)-3
                ret=and_bits(floor(ret/power(2,loc)),15)/#F
        elsif bits=8 then
                return a[loc]/#FF
        elsif bits=16 then
                return (a[loc]*256+a[loc+1])/#FFFF
        end if
        return ret
end function

function Get_Bpp(sequence a, atom loc, atom bits, atom num)
        sequence ret
        ret=repeat(0,num)
        for i = 1 to num do
                ret[i]=Get_Bits(a,loc,bits)
                loc+=bits/8
        end for
        return ret
end function

function Get_sBpp(sequence a, atom loc, atom bits, atom num)
        sequence ret
        ret=repeat(0,num)
        for i = 1 to num do
                ret[i]=Get_sBits(a,loc,bits)
                loc+=bits/8
        end for
        return ret
end function

function Round_Bit(atom a)
        if not integer(a) then return floor(a+1) else return a end if
end function

with trace
global function read_png(sequence a)
atom len,crcC,spot,crc2,IDAT_ptr,ptr,pt2,colormode,filtermode,interlacemethod
atom width,height,Bpp,bits,total_size,Fx,Fa,Fb,Fc,pw,ph,px,py,line_num,FBpp
sequence IDAT
sequence id,data,pal
        a=read_whole_file(a)
        if length(a)<32 then return {-1,0} end if
        if not equal(a[1..8],{137,80,78,71,13,10,26,10}) then return {-1,0} end if
        IDAT={}
        pal=repeat({0,0,0,255},256)
        spot=9
        while 1 do
                len=bytes_to_int(reverse(a[spot..spot+3]))
                spot+=4
                id=a[spot..spot+3]
                if to_print then printf(1,"%s %d\n",{id,len}) end if
                crc2=crc(a[spot..spot+len-1+4],CRC32)
                spot+=4
                data=a[spot..spot+len-1]
                spot+=len
                crcC=bytes_to_int(reverse(a[spot..spot+3]))
                if crc2=crcC then --if to_print then printf(1,"CRC Good #%08x\n",{crcC}) end if
                if equal("IDAT",id) then
                        IDAT&=data
                elsif equal("PLTE",id) then
                        if to_print and not integer(len/3) then printf(1,"Invalid Length\n",{}) end if
                        for i = 0 to len-1 by 3 do
                                pal[1+i/3][1..3]=data[1+i..i+3]
                        end for
                elsif equal("tRNS",id) then
                        for i = 1 to len do
                                pal[i][4]=data[i]
                        end for
                elsif equal("IHDR",id) then
                        width=bytes_to_int(reverse(data[1..4]))
                        height=bytes_to_int(reverse(data[5..8]))
                        bits=data[9]
                        if to_print then printf(1,"Width=%d ",{width}) end if
                        if to_print then printf(1,"Height=%d ",{height}) end if
                        if to_print then printf(1,"Bit Depth=%d ",{bits}) end if
                        colormode=data[10]
                        if colormode=0 then
                                if to_print then puts(1,"Each pixel is a grayscale sample.\n") end if
                                Bpp=bits/8
                        elsif colormode=2 then
                                if to_print then puts(1,"Each pixel is an R,G,B triple.\n") end if
                                Bpp=bits/8*3
                        elsif colormode=3 then
                                if to_print then puts(1,"Each pixel is a palette index; a PLTE chunk must appear.\n") end if
                                Bpp=bits/8
                        elsif colormode=4 then
                                if to_print then puts(1,"Each pixel is a grayscale sample, followed by an alpha sample.\n") end if
                                Bpp=bits/8*2
                        elsif colormode=6 then
                                if to_print then puts(1,"Each pixel is an R,G,B triple, followed by an alpha sample.\n") end if
                                Bpp=bits/8*4
                        else
                                if to_print then puts(1,"Unknown Color Format\n") end if
                        end if
                        if Bpp<1 then FBpp=1 else FBpp=Bpp end if
                        total_size=floor((Bpp*width*height+height)*3)
                        if to_print then printf(1,"Total_size= %d\n",{total_size}) end if
                        if data[11]=0 then if to_print then  puts(1,"Compression Method: deflate/inflate compression with a 32K sliding window\n") end if
                        else if to_print then  puts(1,"Compression Method: Unknown Compression type\n") end if
                        end if
                        if to_print then puts(1,"Filter Method: ") end if
                        if data[12]=0 then if to_print then  puts(1,"(adaptive filtering with five basic filter types)\n") end if
                        else if to_print then  puts(1,"Unknown Filter Type\n") end if
                        end if
                        if to_print then puts(1,"Interlace Method: ") end if
                        interlacemethod=data[13]
                        if interlacemethod=0 then if to_print then  puts(1,"(no interlace)\n") end if
                        elsif interlacemethod=1 then if to_print then  puts(1,"(Adam7 interlace)\n") end if
                        else if to_print then  puts(1,"Unknown Interlace Method\n") end if
                        end if
                end if
                else if to_print then  printf(1,"CRC Bad #%08x\n",{crcC}) end if
                end if
                spot+=4
                if equal("IEND",id) then exit end if
        end while
        a={}
        if to_print then ? {length(IDAT),total_size,Bpp,FBpp} end if
        IDAT=uncompress(IDAT,total_size)
        if to_print then ? {IDAT[1],length(IDAT[2])} end if
        IDAT=IDAT[2]
        IDAT_ptr=allocate(width*height*4)
        mem_set(IDAT_ptr,0,width*height*4)
        ptr=IDAT_ptr
        pt2=1

        if interlacemethod=0 then
        for i = 0 to height-1 do
                filtermode=IDAT[pt2]
                for x = 1 to width*Bpp do
                        if x>=1          then Fx=IDAT[x+pt2]                   else Fx=0 end if
                        if x>FBpp         then Fa=IDAT[x-FBpp+pt2]               else Fa=0 end if
                        if i>0           then Fb=IDAT[x-(1+width*Bpp)+pt2]     else Fb=0 end if
                        if x>FBpp and i>0 then Fc=IDAT[x-FBpp-(1+width*Bpp)+pt2] else Fc=0 end if
                        if filtermode=0 then --nothing
                        elsif filtermode=1 then IDAT[x+pt2]=and_bits(Fx+Fa,#FF)
                        elsif filtermode=2 then IDAT[x+pt2]=and_bits(Fx+Fb,#FF)
                        elsif filtermode=3 then IDAT[x+pt2]=and_bits(Fx+floor((Fa+Fb)/2),#FF)
                        elsif filtermode=4 then IDAT[x+pt2]=and_bits(Fx+Paeth(Fa,Fb,Fc),#FF)
                        end if
                end for
                pt2+=1
                for x=0 to width-1 do
                        if colormode=6 then poke(ptr,Get_sBpp(IDAT,pt2,bits,4)*255) pt2+=Bpp
                        elsif colormode=2 then poke(ptr,Get_sBpp(IDAT,pt2,bits,3)*255&255) pt2+=Bpp
                        elsif colormode=4 then poke(ptr,repeat(Get_sBits(IDAT,pt2,bits)*255,3)&Get_sBits(IDAT,pt2+Bpp/2,bits)*255) pt2+=Bpp
                        elsif colormode=0 then poke(ptr,repeat(Get_sBits(IDAT,pt2,bits)*255,3)&255) pt2+=Bpp
                        elsif colormode=3 then poke(ptr,pal[Get_Bits(IDAT,pt2,bits)+1]) pt2+=Bpp
                        end if
                        ptr+=4
                end for
                pt2=Round_Bit(pt2)
        end for
        elsif interlacemethod=1 then
        for pass= 1 to length(passes) do
        ptr=IDAT_ptr
        pw=get_pass_width(width,pass)
        ph=get_pass_height(height,pass)
        if pw=0 then ph=0 end if
        py=1
        line_num=passes[pass][py][1][2]
        for i = 0 to ph-1 do
                filtermode=IDAT[pt2]
                for x = 1 to pw*Bpp do
                        if x>=1          then Fx=IDAT[x+pt2]                   else Fx=0 end if
                        if x>FBpp         then Fa=IDAT[x-FBpp+pt2]               else Fa=0 end if
                        if i>0           then Fb=IDAT[x-(1+pw*Bpp)+pt2]     else Fb=0 end if
                        if x>FBpp and i>0 then Fc=IDAT[x-FBpp-(1+pw*Bpp)+pt2] else Fc=0 end if
                        if filtermode=0 then --nothing
                        elsif filtermode=1 then IDAT[x+pt2]=and_bits(Fx+Fa,#FF)
                        elsif filtermode=2 then IDAT[x+pt2]=and_bits(Fx+Fb,#FF)
                        elsif filtermode=3 then IDAT[x+pt2]=and_bits(Fx+floor((Fa+Fb)/2),#FF)
                        elsif filtermode=4 then IDAT[x+pt2]=and_bits(Fx+Paeth(Fa,Fb,Fc),#FF)
                        end if
                end for
                pt2+=1
                px=1
                ptr=IDAT_ptr+4*(passes[pass][py][px][1]-1+(line_num-1)*width)
                for x=0 to pw-1 do
                        if colormode=6 then poke(ptr,Get_sBpp(IDAT,pt2,bits,4)*255) pt2+=Bpp
                        elsif colormode=2 then poke(ptr,Get_sBpp(IDAT,pt2,bits,3)*255&255) pt2+=Bpp
                        elsif colormode=4 then poke(ptr,repeat(Get_sBits(IDAT,pt2,bits)*255,3)&Get_sBits(IDAT,pt2+Bpp/2,bits)*255) pt2+=Bpp
                        elsif colormode=0 then poke(ptr,repeat(Get_sBits(IDAT,pt2,bits)*255,3)&255) pt2+=Bpp
                        elsif colormode=3 then poke(ptr,pal[Get_Bits(IDAT,pt2,bits)+1]) pt2+=Bpp
                        end if
                        if (px+1)>length(passes[pass][py]) then
                                ptr+=4*(
                                        ((8-passes[pass][py][px][1])+
                                        (passes[pass][py][1][1])))
                                px=1
                        else
                                px+=1
                                ptr+=4*
                                        (passes[pass][py][px][1]-passes[pass][py][px-1][1])
                        end if
                end for
                pt2=Round_Bit(pt2)
                
                if (py+1)>length(passes[pass]) then
                        line_num+=8-passes[pass][py][1][2]+passes[pass][1][1][2]
                        py=1
                else
                        py+=1
                        line_num+=passes[pass][py][1][2]-passes[pass][py-1][1][2]
                end if
--        Out_TGA(sprintf("log%d.tga",{pass}),IDAT_ptr,width,height,4)
        end for
        end for
        end if
--        Out_TGA("log.tga",IDAT_ptr,width,height,4)
        return {IDAT_ptr,width,height}
end function

sequence png_rgb_pal,png_rgba_pal,png_alpha_pal
global atom
        png_grayscale,
        png_alpha,
        png_width,
        png_height,
        png_bits,
        png_color_type,
        png_compression_method,
        png_filter_method,
        png_interlace_method,
        png_IDAT_size,
        png_bpp,
        png_do_filter
        
        png_do_filter=1
        png_width=0
        png_height=0
        png_bits=8
        png_color_type=6
        png_compression_method=0
        png_filter_method=0
        png_interlace_method=0
        png_IDAT_size=8192

function make_chunk(sequence id,sequence data)
        sequence ret
        ret={}
        ret&=reverse(int_to_bytes(length(data)))
        ret&=id
        ret&=data
        ret&=reverse(int_to_bytes(crc(ret[5..length(ret)],CRC32)))
        return ret
end function

function make_IHDR()
        return make_chunk("IHDR",
                reverse(int_to_bytes(png_width))&--   Width:              4 bytes
                reverse(int_to_bytes(png_height))&--   Height:             4 bytes
                png_bits&--   Bit depth:          1 byte
                png_color_type&--   Color type:         1 byte
                png_compression_method&--   Compression method: 1 byte
                png_filter_method&--   Filter method:      1 byte
                png_interlace_method)--   Interlace method:   1 byte
end function

function make_IDATs(sequence data)
sequence ret
atom spot
        spot=1
        ret={}
        while 1 do
                if spot+png_IDAT_size>length(data) then
                        ret&=make_chunk("IDAT",data[spot..length(data)])
                        exit
                else
                        ret&=make_chunk("IDAT",data[spot..spot+png_IDAT_size-1])
                        spot+=png_IDAT_size
                end if
        end while
        return ret
end function

function signed_byte(integer a)
        if a>127 then a-=#100 end if
        return a
end function

function filter_line(sequence line, sequence last)
        integer Fx,Fa,Fb,Fc
        sequence ret1,ret2,ret3,ret4
        ret1=line
        ret2=line
        ret3=line
        ret4=line
        for i = 2 to length(line) do
                Fx=line[i]
                if i-2>=png_bpp then Fa=line[i-png_bpp] else Fa=0 end if
                if i<=length(last) then Fb=last[i] else Fb=0 end if
                if i-2>=png_bpp and i<=length(last) then Fc=last[i-png_bpp] else Fc=0 end if
                                                          line[1]+=abs(signed_byte(line[i]))
                ret1[i]=and_bits(Fx-Fa,#FF)               ret1[1]+=abs(signed_byte(ret1[i]))
                ret2[i]=and_bits(Fx-Fb,#FF)               ret2[1]+=abs(signed_byte(ret2[i]))
                ret3[i]=and_bits(Fx-floor((Fa+Fb)/2),#FF) ret3[1]+=abs(signed_byte(ret3[i]))
                ret4[i]=and_bits(Fx-Paeth(Fa,Fb,Fc),#FF)  ret4[1]+=abs(signed_byte(ret4[i]))
        end for
        if line[1]<ret1[1] and line[1]<ret2[1] and line[1]<ret3[1] and line[1]<ret4[1] then
                line[1]=0 return line
        elsif ret1[1]<ret2[1] and ret1[1]<ret3[1] and ret1[1]<ret4[1] then
                ret1[1]=1 return ret1
        elsif ret2[1]<ret3[1] and ret2[1]<ret4[1] then
                ret2[1]=2 return ret2
        elsif ret3[1]<ret4[1] then
                ret3[1]=3 return ret3
        else
                ret4[1]=4 return ret4
        end if
end function

procedure add_pal(sequence a)
        if length(png_rgba_pal)<=256 then
                if not find(a,png_rgb_pal) then png_rgb_pal=append(png_rgb_pal,a) end if
                if not find(a,png_rgba_pal) then png_rgba_pal=append(png_rgba_pal,a) end if
        elsif length(png_rgb_pal)<=256 then
                if not find(a,png_rgb_pal) then png_rgb_pal=append(png_rgb_pal,a) end if
        end if
        if png_grayscale and not a[1]=a[2] and a[2]=a[3] then png_grayscale=0 end if
        if not png_alpha and a[4] !=255 then png_alpha=1 end if
end procedure

function convert_colors(sequence encoded)
        sequence ret,pal,bits
        --printf(1,"%d ",{length(png_rgba_pal)})
        if length(png_rgba_pal)<=2 then
                ret=repeat({0},length(encoded))
                for i = 1 to length(encoded) do
                bits={}
                for ii = 2 to length(encoded[i])-3 by 4 do
                        bits&=find(encoded[i][ii..ii+3],png_rgba_pal)-1
                end for
                if remainder(length(bits),8) then
                        bits&=repeat(0,8-remainder(length(bits),8))
                end if
                for ii = 1 to length(bits)-7 by 8 do
                        ret[i]&=
                                bits[ii]*128+
                                bits[ii+1]*64+
                                bits[ii+2]*32+
                                bits[ii+3]*16+
                                bits[ii+4]*8+
                                bits[ii+5]*4+
                                bits[ii+6]*2+
                                bits[ii+7]
                end for
                end for
                png_bits=1
                png_bpp=1
        elsif length(png_rgba_pal)<=4 then
                ret=repeat({0},length(encoded))
                for i = 1 to length(encoded) do
                bits={}
                for ii = 2 to length(encoded[i])-3 by 4 do
                        bits&=find(encoded[i][ii..ii+3],png_rgba_pal)-1
                end for
                if remainder(length(bits),4) then
                        bits&=repeat(0,4-remainder(length(bits),4))
                end if
                for ii = 1 to length(bits)-3 by 4 do
                        ret[i]&=
                                bits[ii]*64+
                                bits[ii+1]*16+
                                bits[ii+2]*4+
                                bits[ii+3]
                end for
                end for
                png_bits=2
                png_bpp=1
        elsif length(png_rgba_pal)<=16 then
                ret=repeat({0},length(encoded))
                for i = 1 to length(encoded) do
                bits={}
                for ii = 2 to length(encoded[i])-3 by 4 do
                        bits&=find(encoded[i][ii..ii+3],png_rgba_pal)-1
                end for
                if remainder(length(bits),2) then
                        bits&=repeat(0,2-remainder(length(bits),2))
                end if
                for ii = 1 to length(bits)-1 by 2 do
                        ret[i]&=
                                bits[ii]*16+
                                bits[ii+1]
                end for
                end for
                png_bits=4
                png_bpp=1
        elsif length(png_rgba_pal)<=256 then
                ret=repeat({0},length(encoded))
                for i = 1 to length(encoded) do
                for ii = 2 to length(encoded[i])-3 by 4 do
                        ret[i]&=find(encoded[i][ii..ii+3],png_rgba_pal)-1
                end for
                end for
                png_bits=8
                png_bpp=1
        else png_bpp=4 return encoded
        end if
                png_color_type=3
                pal={}
                png_alpha_pal={}
                for i = 1 to length(png_rgba_pal) do
                        pal&=png_rgba_pal[i][1..3]
                        png_alpha_pal&=png_rgba_pal[i][4]
                end for
                png_rgba_pal=pal

        return ret
end function

global procedure write_png(sequence fn, sequence imagedata)
--imagedata={mem,width,height}
--pal=repeat(repeat(3 or 4),0 to 256)
--fn=filename
sequence encoded,pass,out,encline,pass_nums,pix
atom filtermode,pw,ph,iptr,px,py,ipx,ipy
        png_rgba_pal={}
        png_rgb_pal={}
        png_alpha_pal={}
        encoded={}
        pass_nums={}
        png_width=imagedata[2]
        png_height=imagedata[3]
        out={}
        png_grayscale=1
        png_alpha=0
        png_bits=8
        png_bpp=4
        png_color_type=6
        if png_interlace_method=0 then
                for i = 0 to png_height-1 do
                        filtermode=0
                        encline={filtermode}
                        for x=0 to png_width-1 do
                                pix=peek({imagedata[1]+(x+i*png_width)*4,4})
                                add_pal(pix)
                                encline&=pix
                        end for
                        encoded=append(encoded,encline)
                        encline={}
                end for
                encoded=convert_colors(encoded)
                for i = 1 to length(encoded) do
                        if not png_do_filter then out&=encoded[i]
                        elsif 1 then out&=encoded[i] encoded[i]=0
                        elsif i = 1 then out&=filter_line(encoded[i],{})
                        else          out&=filter_line(encoded[i],encoded[i-1]) encoded[i-1]=0
                        end if
                end for
        elsif png_interlace_method=1 then
                for cpass = 1 to length(passes) do
                        pass=passes[cpass]
                        pw=get_pass_width(png_width,cpass)
                        ph=get_pass_height(png_height,cpass)
                        if pw=0 then ph=0 end if
                        iptr=imagedata[1]
                        py=1
                        ipy=pass[py][1][2]-1
                        for i = 0 to ph-1 do
                                filtermode=0
                                encline={filtermode}
                                px=1
                                ipx=pass[py][px][1]-1
                                for x=0 to pw-1 do
                                        pix=peek({imagedata[1]+4*(ipx+ipy*png_width),4})
                                        add_pal(pix)
                                        encline&=pix
                                        if px+1>length(pass[py]) then
                                                ipx+=8-pass[py][px][1]+pass[py][1][1]
                                                px=1
                                        else
                                                px+=1
                                                ipx+=pass[py][px][1]-pass[py][px-1][1]
                                        end if
                                end for
                                pass_nums&=cpass
                                encoded=append(encoded,encline)
                                encline={}
                                if py+1>length(pass) then
                                        ipy+=8-pass[py][1][2]+pass[1][1][2]
                                        py=1
                                else
                                        py+=1
                                        ipy+=pass[py][1][2]-pass[py-1][1][2]
                                end if
                        end for
                end for
                encoded=convert_colors(encoded)
                for i = 1 to length(encoded) do
                        if not png_do_filter then out&=encoded[i]
                        elsif i = 1 then out&=filter_line(encoded[i],{})
                        elsif pass_nums[i]!=pass_nums[i-1] then out&=filter_line(encoded[i],{}) encoded[i-1]=0
                        else          out&=filter_line(encoded[i],encoded[i-1]) encoded[i-1]=0
                        end if
                end for
        end if
        encoded=compress(out)
        encoded=encoded[2]
        if png_color_type=6 then
                write_whole_file(fn,{137,80,78,71,13,10,26,10}&make_IHDR()&make_IDATs(encoded)&make_chunk("IEND",{}))
        else
                if png_alpha then
                        write_whole_file(fn,{137,80,78,71,13,10,26,10}&
                        make_IHDR()&
                        make_chunk("PLTE",png_rgba_pal)&
                        make_chunk("tRNS",png_alpha_pal)&
                        make_IDATs(encoded)&make_chunk("IEND",{}))
                else
                        write_whole_file(fn,{137,80,78,71,13,10,26,10}&
                        make_IHDR()&
                        make_chunk("PLTE",png_rgba_pal)&
                        make_IDATs(encoded)&make_chunk("IEND",{}))
                end if
        end if
end procedure

